#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pl = pair<ll, ll>;
using vpl = vector<pl>;

pair<pl, ll> get_root(map<pl, pair<pl, ll>> &comps, pl p1) {
	if (comps[p1].first == p1) return comps[p1];
	return get_root(comps, comps[p1].first);
}

void dsu (map<pl, pair<pl, ll>> &comps, pl p1, pl p2) {
	pair<pl, ll>c1 = get_root(comps, p1);
	pair<pl, ll>c2 = get_root(comps, p2);
	if (c1.second < c2.second) {
		swap(c1, c2);
	}
	if (c1.second == c2.second) {
		c1.second += 1;
	}
	c2.first = c1.first;
	comps[c1.first] = c1;
	comps[c2.first] = c2;
}

bool contains(vector<pl> &v, pl p) {
	return find(v.begin(), v.end(), p) != v.end();
}

int main() {
	int m;
	map<pl, vpl> conns;
	map<pl, pair<pl, ll>> comps;
	vpl neigh = {{-1, -1}, {1, -1}, {-1, 1}, {1, 1}};
	int max_walls = 3;
	cin >> m;
	for (int i = 0; i < m; i++) {
		ll x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		if (x1 > x2) swap(x1, x2);
		if (y1 > y2) swap(y1, y2);
		if (comps.count({x1, y1}) == 0) {
		       comps[{x1, y1}] = {{x1,y1},1};
		       conns[{x1, y1}] = {};
		}
		if (comps.count({x2, y2}) == 0) {
			comps[{x2, y2}] = {{x2, y2}, 1};
			conns[{x2, y2}] = {};
		}
		if (get_root(comps, {x1, y1}) == get_root(comps, {x2, y2})) {
			cout << 0 << endl;
			return 0;
		}
		dsu(comps, {x1, y1}, {x2, y2});
		conns[{x1, y1}].push_back({x2, y2});
		conns[{x2, y2}].push_back({x1, y1});

 		for (auto [dx, dy] : neigh) {
			ll nx = x1 + dx;
			ll ny = y1 + dy;
			if ((nx == x2 && ny == y2) || contains(conns[{x1, y1}], {nx, ny})) continue;
			if (comps.count({nx, ny}) != 0) {
				if (get_root(comps, {nx, ny}) == get_root(comps, {x1, y1})) {
					max_walls = 1;
				}
			}
		}
 		for (auto [dx, dy] : neigh) {
			ll nx = x2 + dx;
			ll ny = y2 + dy;
			if ((nx == x1 && ny == y1) || contains(conns[{x2, y2}], {nx, ny})) continue;
			if (comps.count({nx, ny}) != 0) {
				if (x2 == -1 && y2 == 0) {
					cout << get_root(comps, {nx, ny}) ==  get_root(comps, {x2, y2}) << endl;}
				if (get_root(comps, {nx, ny}) == get_root(comps, {x2, y2})) {
					max_walls = 1;
				}
			}
		}
			if (x1 == x2) {
				if (conns.count({x1 + 1, y1}) != 0) {
					vector<pl> &v = conns[{x1+1, y1}];
					if (contains(v, {x1+1, y2}) || contains(v, {x1, y1})) {
						max_walls = min(max_walls, 2);
					}
				}
				if (conns.count({x1 - 1, y1}) != 0) {
					vector<pl> &v = conns[{x1 -1, y1}];
					if (contains(v, {x1 - 1, y2}) || contains(v, {x1, y1})) {
						max_walls = min(max_walls, 2);
					}
				}
				vector<pl> &v = conns[{x2, y2}];
				if (contains(v, {x1 - 1, y2}) || contains(v, {x1+1, y2})) {
					max_walls = min(max_walls, 2);
				}
			} else {
				if (conns.count({x1, y1-1}) != 0) {
					vector<pl> &v = conns[{x1, y1-1}];
					if (contains(v, {x2, y1-1}) || contains(v, {x1, y1})) {
						max_walls = min(max_walls, 2);
					}
				}
				if (conns.count({x1, y1+1}) != 0) {
					vector<pl> &v = conns[{x1, y1+1}];
					if (contains(v, {x1, y2+1}) || contains(v, {x1, y1})) {
						max_walls = min(max_walls, 2);
					}
				}
				
				vector<pl> &v = conns[{x2, y2}];
				if (contains(v, {x2, y2-1}) || contains(v, {x2, y1+1})) {
					max_walls = min(max_walls, 2);
				}
			}
		
	}
	cout << max_walls << endl;
	return 0;
}

